AM263Px MCU+ SDK: APIs for Queue

| AM263Px MCU+ SDK 26.00.00 |

Data Structures | Functions | Typedefs
APIs for Queue
APIs for Driver Porting Layer

## Introduction

For more details and example usage, see Queue

## Data Structures
struct | QueueP_Elem
| Opaque QueueP element. More...
struct | QueueP_Object
| Opaque task object used with the task APIs. More...

## Functions
QueueP_Handle | QueueP_create (QueueP_Object *obj)
| Function to create a queue. More...
int32_t | QueueP_delete (QueueP_Handle handle)
| Function to delete a queue. More...
void * | QueueP_get (QueueP_Handle handle)
| Function to Get the element at the front of the queue. This function removes an element from the front of a queue and returns it. More...
int32_t | QueueP_put (QueueP_Handle handle, void *elem)
| Function to Put an element at end of queue. More...
uint32_t | QueueP_isEmpty (QueueP_Handle handle)
| Function to perform queue empty check. More...

## Typedefs
typedef QueueP_Object * | QueueP_Handle
| Opaque client reference to an instance of a QueueP. More...

## State codes for current queue state
#define | QueueP_OBJECT_SIZE_MAX (8u)
#define | QueueP_NOTEMPTY (0U)
#define | QueueP_EMPTY (1U)

## Macro Definition Documentation

## ◆ QueueP_OBJECT_SIZE_MAX

#define QueueP_OBJECT_SIZE_MAX (8u)

## ◆ QueueP_NOTEMPTY

#define QueueP_NOTEMPTY (0U)

## ◆ QueueP_EMPTY

#define QueueP_EMPTY (1U)

## Typedef Documentation

## ◆ QueueP_Handle

typedef QueueP_Object* QueueP_Handle

Opaque client reference to an instance of a QueueP.

A QueueP_Handle returned from the QueueP_create represents that instance and is used in the other instance based functions

## Function Documentation

## ◆ QueueP_create()

QueueP_Handle QueueP_create | ( | QueueP_Object * | obj | ) |

Function to create a queue.

Parameters

  obj | [in] Pointer to QueueP_Object.

Returns
  A QueueP_Handle on success or a NULL on an error

## ◆ QueueP_delete()

int32_t QueueP_delete | ( | QueueP_Handle | handle | ) |

Function to delete a queue.

Parameters

  handle | [in] A QueueP_Handle returned from QueueP_create

Returns
  Status of the functions
  - QueueP_OK: Deleted the queue instance
  - QueueP_FAILURE: Failed to delete the queue instance

## ◆ QueueP_get()

void* QueueP_get | ( | QueueP_Handle | handle | ) |

Function to Get the element at the front of the queue. This function removes an element from the front of a queue and returns it.

Parameters

  handle | [in] A QueueP_Handle returned from QueueP_create

Returns
  pointer to the element or NULL incase of empty queue

## ◆ QueueP_put()

int32_t QueueP_put | ( | QueueP_Handle | handle,
|  | void * | elem
| ) |  |

Function to Put an element at end of queue.

Parameters

  handle | [in] A QueueP_Handle returned from QueueP_create
  elem | [in] Pointer to new queue element

Returns
  Status of the functions
  - QueueP_OK: Put the element at end of queue
  - QueueP_FAILURE: Failed to Put the element at end of queue

## ◆ QueueP_isEmpty()

uint32_t QueueP_isEmpty | ( | QueueP_Handle | handle | ) |

Function to perform queue empty check.

Parameters

  handle | [in] A QueueP_Handle returned from QueueP_create

Returns
  Current state of the Queue
  - QueueP_NOTEMPTY: queue is not empty
  - QueueP_EMPTY: queue is empty